import {Provider, connect} from 'react-redux';
import {createStore, combineReducers, applyMiddleware, bindActionCreators} from 'redux';
import thunk from 'redux-thunk';
import {actionPromise} from "./index"
import {gql, actionGoods} from "../reducers/index";
import { useEffect } from 'react';

  // const Goods = ({className = "goods",  goods = [], getData, id}) => {
  //     useEffect(() =>  getData(id), [id])

  //     return(
  //         <>
  //           <div className = "goodsWrapper">
  //               <h4>Товары</h4>
  //               <div className = {className}>          
  //               {goods.map(good => <OneGood key = {good._id} name = {good.name} price = {good.price} image = {good.images[0].url}/>)}
  //               </div>
  //           </div>
  //         </>
  //     )
  // }
  
  const getGoods = state => {
  
    if(state.promiseRed.goods && state.promiseRed.goods.payload) {
        return state.promiseRed.goods.payload.data.GoodFind
    }
  
    return [];
  };



  
  const mapStateToProps = state => ({
    state: state,
    goods: getGoods(state)
  });
  
  const mapDispatchToProps = dispatch => bindActionCreators({
    getData: actionGoods
  }, dispatch);
  


const OneGood = ({className = "oneGood", image, name, price}) => {

  return (
    <>
    <div className = {className}>
      <h5>{name}</h5>

      <img width = "120px" src = {`http://shop-roles.asmer.fs.a-level.com.ua/${image}`}/>
      <span>{price}грн</span>
    </div>
    </>
  )
}



const GoodsCategory = ({goods = [], id, tittle = "Товари", getData = actionGoods}) => {
  useEffect(() =>  getData(id), [id])
  return(
      <>
        <div className = "goodsWrapper">
            <GoodsList goodsArr = {goods} className = "goods" fn = {console.log("pratsuu")}/>
        </div>
      </>
  )
}


const CGoodsCategory = connect(mapStateToProps, mapDispatchToProps)(GoodsCategory);

const GoodsList = ({goodsArr, className = "goods"}) => {
  return (
  <div className = {className}>          
  {goodsArr.map((good) => <OneGood key = {good._id} name = {good.name} price = {good.price} image = {good.images[0].url}/>)}
  </div>
  )
}

  export default CGoodsCategory;